import tools.*;
import io.*;

class Eval extends Program {
  void run() {
    print("Ingrese el valor de n : ");
    int n= readInt();
    int[] aOrig= fabricar(n);
    desordenar(aOrig, n);
    // muestraArreglo(aOrig, n);
    
    // Seleccin y reemplazo con colas
    {
      Queue cola= new Queue();
      llenar(aOrig, n, cola);
      long tIni= currentMillis();
      // ordenar(cola);
      long tFin= currentMillis();
      // muestraCola(cola);
      // println("Seleccion y reemplazo con colas= "+(tFin-tIni)+" milisegundos");
    }

    // Seleccin y reemplazo con arreglos
    {
      int[] a= new int[n];
      copiar(aOrig, n, a);
      long tIni= currentMillis();
      // seleccion(a, n);
      long tFin= currentMillis();
      // muestraArreglo(a, n);
      // println("Seleccion y reemplazo con arreglos= "+(tFin-tIni)+" milisegundos");
    }

    // Burbuja con arreglos
    {
      int[] a= new int[n];
      copiar(aOrig, n, a);
      long tIni= currentMillis();
      // burbuja(a, n);
      long tFin= currentMillis();
      // muestraArreglo(a, n);
      // println("Burbuja con arreglos= "+(tFin-tIni)+" milisegundos");
    }

    // Quicksort con colas
    {
      Queue cola= new Queue();
      llenar(aOrig, n, cola);
      long tIni= currentMillis();
      // quicksort1(cola);
      long tFin= currentMillis();
      // muestraCola(cola);
      // println("Quicksort con colas= "+(tFin-tIni)+" milisegundos");
    }

    // Quicksort con arreglos
    {
      int[] a= new int[n];
      copiar(aOrig, n, a);
      long tIni= currentMillis();
      quicksort(a, 0, n-1);
      long tFin= currentMillis();
      // muestraArreglo(a, n);
      valida(a, n);
      println("Quicksort con arreglos= "+(tFin-tIni)+" milisegundos");
    }

  }
  int[] fabricar(int n) {
    int[] a= new int[n];
    int i= 0;
    while (i<n) {
      a[i]= i+1;
      i= i+1;
    }
    return a;
  }
  void muestraArreglo(int[] a, int n) {
    int i=0;
    while (i<n) {
      print(a[i]+" ");
      i= i+1;
    }
    println();
  }
  void copiar(int[] a, int n, int[] b) {
    int i= 0;
    while (i<n) {
      b[i]= a[i];
      i= i+1;
    }
  }
  void desordenar(int[] a, int n) {
    int i= n-1;
    while (i>=0) {
      int j= trunc(random()*(i+1));
      int aux= a[i];
      a[i]= a[j];
      a[j]= aux;
      i= i-1;
    }
  }
  void valida(int[] a, int n) {
    int i=0;
    while (i<n) {
      if (a[i]!=i+1)
        throw new Error("Falla algoritmo");
      i= i+1;
    }
  }
  void seleccion(int[ ] a, int n) {
    int i= 0;
    while (i<n) {
      // Buscamos la posicion del minimo en a[i], ai+1], ..., a[n-1]
      int k= i;
      int j= i+1;
      while (j<n) {
        if (a[j]<a[k])
          k= j;
        j= j+1;
      }
      // intercambiamos a[i] con a[j]
      int aux= a[i];
      a[i]= a[k];
      a[k]= aux;
      i= i+1;
    }
  }
  void burbuja(int[ ] a, int n) {
    int iult= n-1;
    boolean cambio= true;
    while (cambio) {
      int i= 0;
      cambio= false;
      while (i<iult) {
        if (a[i]>a[i+1]) {
          // intercambiar
          int aux= a[i];
          a[i]= a[i+1];
          a[i+1]= aux;
          cambio= true;
        }
        i= i+1;
      }
      iult= iult-1;
    }
  }
  void llenar(int[] a, int n, Queue cola) {
    int i= 0;
    while (i<n) {
      cola.put(a[i]);
      i= i+1;
    }
  }
  void muestraCola(Queue cola) {
    int tamanno= cola.size();
    int i= 1;
    while (i<=tamanno) {
      int x= cola.getInt();
      print(x+" ");
      cola.put(x); // regresamos el valor al final de la cola
      i= i+1;
    }
    println();
  }
  int minimo(Queue cola) {
    int tamanno= cola.size();
    int min= cola.getInt();
    int i= 1;
    while (i<tamanno) {
      int x= cola.getInt();
      if (x>min)
        cola.put(x);
      else {
        cola.put(min);
        min= x;
      }
      i= i+1;
    }
    return min;
  }
  void ordenar(Queue cola) {
    // Construimos la cola auxiliar
    Queue aux= new Queue();
    // Hacemos un ciclo extrayendo el mnimo hasta vaciar la cola
    while (! cola.isEmpty())
      aux.put(minimo(cola)); // el mnimo lo agregamos al final de aux
    // Ahora aux est ordenada.
    // Transferimos los elementos de aux a cola.
    while (! aux.isEmpty())
      cola.put(aux.getInt());
  }
  void quicksort1(Queue cola) {
    if (cola.isEmpty())
      return;
    int pivot= cola.getInt();
    Queue menores= new Queue();
    Queue mayores= new Queue();
    while (!cola.isEmpty()) {
      int x= cola.getInt();
      if (x>pivot)
        mayores.put(x);
      else
        menores.put(x);
    }
    quicksort1(menores);
    quicksort1(mayores);
    while (!menores.isEmpty())
      cola.put(menores.getInt());
    cola.put(pivot);
    while (!mayores.isEmpty())
      cola.put(mayores.getInt());
  }
  void quicksort(int[] a, int imin, int imax) {
    if (imin>=imax)
      return;
    int k= particionar(a, imin, imax);
    quicksort(a, imin, k-1);
    quicksort(a, k+1, imax);
  }
  int particionar(int[] a, int imin, int imax) {
    int ipiv= imin;
    int k= imin;
    int j= k+1;
    while (j<=imax) {
      if (a[j]<a[ipiv] ) {
        k++;
        intercambiar(a, k, j);
      }
      j= j+1;
    }
    intercambiar(a, k, ipiv);
    return k;
  }
  final void intercambiar(int[] a, int i, int j) {
    int aux= a[j];
    a[j]= a[i];
    a[i]= aux;
  }
}
