package robot;
import tools.*;
import console.*;
import java.awt.*;

public class Tortuga {
  Console c;
  static Console defC= Tools.getGraphConsole();
  double x, y, angle;
  boolean showing= true;
  Color clr= Color.black;

  // Constructor tpico
  public Tortuga() {
    this(defC, defC.maxx()/2, defC.maxy()/2, 0);
  }

  public Tortuga(double x, double y, double angle) {
    this(defC, x, y, angle);
  }

  // Alternate constructor
  public Tortuga(Console c, double x, double y, double angle) {
    this.c= c;
    this.x= x;
    this.y= y;
    this.angle= angle;
  }

  public void defColor(Color clr) {
    this.clr= clr;
  }

  public void defPosicion(double x, double y) {
    this.x= x;
    this.y= y;
  }

  public void defAngulo(double angle) {
    this.angle= angle;
  }

  public void virarDer(double turnAngle) {
    angle+= turnAngle;
  }

  public void virarIzq(double turnAngle) {
    angle-= turnAngle;
    angle= angle%360;
  }

  public void mostrarRastro() {
    showing= true;
  }

  public void ocultarRastro() {
    showing= false;
  }

  public void mover(double dist) {
    double rAngle= (angle*Math.PI)/180;
    double newx= x+Math.cos(rAngle)*dist;
    double newy= y+Math.sin(rAngle)*dist;
    if (showing) {
      c.setColor(clr);
      c.drawLine((int)(x+0.5),(int)(y+0.5),
                 (int)(newx+0.5), (int)(newy+0.5));
    }
    x= newx;
    y= newy;
  }

  public double coordx() { return x; }
  public double coordy() { return y; }
  public double maxx() { return c.maxx(); }
  public double maxy() { return c.maxy(); }
  public void enRojo() { clr= Color.red; }
  public void enVerde() { clr= Color.green; }
  public void enAzul() { clr= Color.blue; }
  public void enNegro() { clr= Color.black; }
}
