package tools;

public class Array {

  Object[] table;

  // Constructor
  // ***********

  public Array(int size) {
    table= new Object[size];
  }

  // Definiciones
  // ************

  public void put(int k, int v) {
    table[k]= new Integer(v);
  }
  public void put(int k, double v) {
    table[k]= new Double(v);
  }
  public void put(int k, boolean v) {
    table[k]= new Boolean(v);
  }
  public void put(int k, String v) {
    table[k]= v;
  }

  // Consultas
  // *********

  // Llaves enteras
  public int getInt(int k) {
    Object o= getObject(k);
    if (! (o instanceof Integer) )
      Tools.fatalError("Value associated with "+k+" is not an int");
    return ((Integer)o).intValue();
  }
  public double getDouble(int k) {
    Object o= getObject(k);
    if (! (o instanceof Number) )
      Tools.fatalError("Value associated with "+k+" is not a double");
    return ((Number)o).doubleValue();
  }
  public String getString(int k) {
    Object o= getObject(k);
    if (! (o instanceof String) )
      Tools.fatalError("Value associated with "+k+" is not a String");
    return (String)o;
  }
  public boolean getBoolean(int k) {
    Object o= getObject(k);
    if (! (o instanceof Boolean) )
      Tools.fatalError("Value associated with "+k+" is not a boolean");
    return ((Boolean)o).booleanValue();
  }
  public Object getObject(int k) {
    Object o= table[k];
    if (o==null) 
      Tools.fatalError("No value has been associated to index "+k);
    return o;
  }

  // Consultas sobre el tipo asociado
  // ********************************

  // Llaves enteras
  public boolean isInt(int k) {
    Object o= table[k];
    return o!=null && (o instanceof Integer);
  }
  public boolean isDouble(int k) {
    Object o= table[k];
    return o!=null && ( (o instanceof Double) || (o instanceof Integer) );
  }
  public boolean isString(int k) {
    Object o= table[k];
    return o!=null && (o instanceof String);
  }
  public boolean isBoolean(int k) {
    Object o= table[k];
    return o!=null && (o instanceof Boolean);
  }

  // Otros
  // *****

  public int size() { return table.length; }
}
