package tools;

import java.util.*;

public class Map {

  Hashtable table= new Hashtable();

  // Definiciones
  // ************

  public void put(int k, int v) {
    table.put(new Integer(k), new Integer(v));
  }
  public void put(int k, double v) {
    table.put(new Integer(k), new Double(v));
  }
  public void put(int k, boolean v) {
    table.put(new Integer(k), new Boolean(v));
  }
  public void put(int k, String v) {
    table.put(new Integer(k), v);
  }

  // Consultas
  // *********

  // Llaves enteras
  public int getInt(int k) {
    Object o= getObject(k);
    if (! (o instanceof Integer) )
      Tools.fatalError("Value associated with "+k+" is not an int");
    return ((Integer)o).intValue();
  }
  public double getDouble(int k) {
    Object o= getObject(k);
    if (! (o instanceof Number) )
      Tools.fatalError("Value associated with "+k+" is not a double");
    return ((Number)o).doubleValue();
  }
  public String getString(int k) {
    Object o= getObject(k);
    if (! (o instanceof String) )
      Tools.fatalError("Value associated with "+k+" is not a String");
    return (String)o;
  }
  public boolean getBoolean(int k) {
    Object o= getObject(k);
    if (! (o instanceof Boolean) )
      Tools.fatalError("Value associated with "+k+" is not a boolean");
    return ((Boolean)o).booleanValue();
  }
  public Object getObject(int k) {
    Object o= table.get(new Integer(k));
    if (o==null) 
      Tools.fatalError("No value has been associated with key "+k);
    return o;
  }

  // Consultas sobre existencia de una asociacion
  // ********************************************

  public boolean isMapped(int k) {
    return table.get(new Integer(k))!=null;
  }

  // Consultas sobre el tipo asociado
  // ********************************

  // Llaves enteras
  public boolean isInt(int k) {
    Object o= table.get(new Integer(k));
    return o!=null && (o instanceof Integer);
  }
  public boolean isDouble(int k) {
    Object o= table.get(new Integer(k));
    return o!=null && ( (o instanceof Double) || (o instanceof Integer) );
  }
  public boolean isString(int k) {
    Object o= table.get(new Integer(k));
    return o!=null && (o instanceof String);
  }
  public boolean isBoolean(int k) {
    Object o= table.get(new Integer(k));
    return o!=null && (o instanceof Boolean);
  }

  // Eliminaciones
  // *************

  public void remove(int k) { table.remove(new Integer(k)); }

  // Otros
  // *****

  public int size() { return table.size(); }
  public KeyEnum keys() { return new KeyEnum(this); }
}
