package tools;

import java.util.*;

public class Queue {
  Vector vec= new Vector();
  public int size() { return vec.size(); }
  public boolean isEmpty() { return vec.isEmpty(); }

  // Adicion
  public void put(int i) {
    vec.addElement(new Integer(i));
  }
  public void put(double x) {
    vec.addElement(new Double(x));
  }
  public void put(String s) {
    vec.addElement(s);
  }
  public void put(boolean b) {
    vec.addElement(new Boolean(b));
  }
  public void put(Object o) {
    vec.addElement(o);
  }

  // Extraccion
  public int getInt() {
    Object o= get();
    if (! (o instanceof Integer) )
      Tools.fatalError("The first element in the queue is not an int");
    return ((Integer)o).intValue();
  }
  public double getDouble() {
    Object o= get();
    if (o instanceof Double)
      return ((Double)o).doubleValue();
    else if (o instanceof Integer)
      return ((Integer)o).doubleValue();
    else
      Tools.fatalError("The first element in the queue is not a double");
    return 0.0;
  }
  public String getString() {
    Object o= get();
    if (! (o instanceof String) )
      Tools.fatalError("The first element in the queue is not a String");
    return (String)o;
  }
  public boolean getBoolean() {
    Object o= get();
    if (! (o instanceof Boolean) )
      Tools.fatalError("The first element in the queue is not a boolean");
    return ((Boolean)o).booleanValue();
  }
  public Object get() {
    if (vec.isEmpty())
      Tools.fatalError("The queue is empty");
    Object o= vec.elementAt(0);
    vec.removeElementAt(0);
    return o;
  }

  // El primero
  public int firstInt() {
    Object o= first();
    if (! (o instanceof Integer) )
      Tools.fatalError("The first element in the queue is not an int");
    return ((Integer)o).intValue();
  }
  public double firstDouble() {
    Object o= first();
    if (o instanceof Double)
      return ((Double)o).doubleValue();
    else if (o instanceof Integer)
      return ((Integer)o).doubleValue();
    else
      Tools.fatalError("The first element in the queue is not a double");
    return 0.0;
  }
  public String firstString() {
    Object o= first();
    if (! (o instanceof String) )
      Tools.fatalError("The first element in the queue is not a String");
    return (String)o;
  }
  public boolean firstBoolean() {
    Object o= first();
    if (! (o instanceof Boolean) )
      Tools.fatalError("The first element in the queue is not a boolean");
    return ((Boolean)o).booleanValue();
  }
  public Object first() {
    if (vec.isEmpty())
      Tools.fatalError("The queue is empty");
    return vec.elementAt(0);
  }

  // Consultas de tipo
  public boolean isInt() {
    return first() instanceof Integer;
  }
  public boolean isDouble() {
    Object o= first();
    return (o instanceof Double) || (o instanceof Integer);
  }
  public boolean isString() {
    return first() instanceof String;
  }
  public boolean isBoolean() {
    return first() instanceof Boolean;
  }
}
