package tools;

import java.util.*;

public class StringMap {

  Hashtable table= new Hashtable();

  // Definiciones
  // ************

  public void put(String k, int v) {
    table.put(k, new Integer(v));
  }
  public void put(String k, double v) {
    table.put(k, new Double(v));
  }
  public void put(String k, boolean v) {
    table.put(k, new Boolean(v));
  }
  public void put(String k, String v) {
    table.put(k, v);
  }

  // Consultas
  // *********

  public int getInt(String k) {
    Object o= getObject(k);
    if (! (o instanceof Integer) )
      Tools.fatalError("Value associated with key "+k+" is not an int");
    return ((Integer)o).intValue();
  }
  public double getDouble(String k) {
    Object o= getObject(k);
    if (! (o instanceof Number) )
      Tools.fatalError("Value associated with key "+k+" is not a double");
    return ((Number)o).doubleValue();
  }
  public String getString(String k) {
    Object o= getObject(k);
    if (! (o instanceof String) )
      Tools.fatalError("Value associated with key "+k+" is not a String");
    return (String)o;
  }
  public boolean getBoolean(String k) {
    Object o= getObject(k);
    if (! (o instanceof Boolean) )
      Tools.fatalError("Value associated with key "+k+" is not a boolean");
    return ((Boolean)o).booleanValue();
  }
  public Object getObject(String k) {
    Object o= table.get(k);
    if (o==null)
      Tools.fatalError("No value has been associated with key "+k);
    return o;
  }

  // Consultas sobre existencia de una asociacion
  // ********************************************

  public boolean isMapped(String k) {
    return table.get(k)!=null;
  }

  // Consultas sobre el tipo asociado
  // ********************************

  public boolean isInt(String k) {
    Object o= table.get(k);
    return o!=null && (o instanceof Integer);
  }
  public boolean isDouble(String k) {
    Object o= table.get(k);
    return o!=null && ( (o instanceof Double) || (o instanceof Integer) );
  }
  public boolean isString(String k) {
    Object o= table.get(k);
    return o!=null && (o instanceof String);
  }
  public boolean isBoolean(String k) {
    Object o= table.get(k);
    return o!=null && (o instanceof Boolean);
  }

  // Eliminaciones
  // *************

  public void remove(String k) { table.remove(k); }

  // Otros
  // *****

  public int size() { return table.size(); }
  public StringKeyEnum keys() { return new StringKeyEnum(this); }
}
