package tools;

import java.util.*;

public class WordParser {
  boolean eos= false;
  StringTokenizer tokenizer;

  public WordParser(String str) {
    tokenizer= new StringTokenizer(str);
  }

  public WordParser(String str, String seps) {
    tokenizer= new StringTokenizer(str, seps);
  }

  public String readString() {
    if (tokenizer.hasMoreTokens())
      return tokenizer.nextToken();
    else {
      eos= true;
      return null;
    }
  }

  public boolean hasMoreWords() { return tokenizer.hasMoreTokens(); }
  public boolean eosReached() { return eos; }
    
  public int readInt() {
    String str= readString();
    return eos ? 0 : Integer.parseInt(str);
  }

  public double readDouble() {
    String str= readString();
    return eos ? 0. : new Double(str).doubleValue();
  }
}
